(function(){"use strict";try{if(typeof document!="undefined"){var e=document.createElement("style");e.appendChild(document.createTextNode(".mk-input{min-height:1.4em}.mk-input span{outline:none;white-space:pre-wrap}.mk-suggestions{border:1px solid #ccc;max-height:186px;overflow-y:auto;padding-left:0;position:absolute;background:white;width:fit-content;min-width:100px;margin-top:0;margin-bottom:0;transition:1.1s ease-out;filter:blur(0);transform:scale(1);opacity:1;visibility:visible;color:#000;border-radius:4%;box-shadow:0 3px 6px -2px #0009}.mk-suggestions li{padding:.5rem}.mk-suggestions li:hover,.mk-suggestion-active{background-color:#cce9ff;color:#2589f5;cursor:pointer}")),document.head.appendChild(e)}}catch(i){console.error("vite-plugin-css-injected-by-js",i)}})();
import Ce, { useContext as Bt, Children as Ut, isValidElement as Xe, useRef as V, useLayoutEffect as Vt, forwardRef as nt, useEffect as X, useMemo as U, useCallback as ie, useState as we } from "react";
const F = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var j = /* @__PURE__ */ ((r) => (r.LABEL = "__label__", r.VALUE = "__value__", r))(j || {});
const Ze = "mk-input", Qe = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: [],
  index: 0
}, Yt = ["onFocus", "onBlur", "onKeyDown", "onClick"], Kt = new RegExp(/^\w*/);
class Gt {
  constructor(e, n) {
    this.raw = e, this.uniRegExp = n, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let e = this.uniRegExp.exec(this.raw);
    if (e === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [n, a, o] = this.extractPieces(e);
    return this.raw = o, { done: !1, value: [n, a] };
  }
  extractPieces(e) {
    const n = this.extractMark(e), a = n.input.substring(0, n.index), o = n.input.substring(n.index + n.annotation.length);
    return [a, n, o];
  }
  extractMark(e) {
    let n = e[0], a = 0, o = e[1], i = e[2];
    for (; !(o || i); )
      a++, o = e[2 * a + 1], i = e[2 * a + 2];
    let l = e.index, f = e.input;
    return { annotation: n, label: o, value: i, input: f, index: l, childIndex: a };
  }
}
class ce {
  get regExps() {
    return this.markups.map(Ht);
  }
  static split(e, n) {
    const a = n.map((o) => o.markup);
    return () => new ce(a).split(e);
  }
  constructor(e) {
    this.markups = e, this.uniRegExp = new RegExp(this.regExps.map((n) => n.source).join("|"));
  }
  split(e) {
    return this.iterateMatches(e);
  }
  iterateMatches(e) {
    const n = [];
    for (let [a, o] of new Gt(e, this.uniRegExp))
      n.push(a), o !== null && n.push(qt(o, this.markups[o.childIndex]));
    return n;
  }
}
const at = Object.assign, Ht = (r) => {
  const e = oe(r), n = r[r.indexOf(j.LABEL) + j.LABEL.length], a = r[r.indexOf(j.VALUE) + j.VALUE.length];
  return new RegExp(
    e.replace(j.LABEL, `([^${oe(n || "")}]+?)`).replace(j.VALUE, `([^${oe(a || "")}]+?)`)
  );
};
function xe(r, e, n) {
  let a = r.replace(j.LABEL, e);
  return n ? a.replace(j.VALUE, n) : a;
}
function Nr(r, e, ...n) {
  return n.length ? new ce(n).split(r).reduce((o, i) => o += le(i) ? e(i) : i, "") : r;
}
const oe = (r) => r.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function et(r, e) {
  let n = "";
  for (let a of r)
    n += le(a) ? xe(e[a.childIndex].markup, a.label, a.value) : a;
  return n;
}
const qt = (r, e) => r.annotation !== xe(e, r.label, r.value) ? { ...r, label: r.value, value: r.label } : r, ue = (r, e = 0) => {
  let n = 3735928559 ^ e, a = 1103547991 ^ e;
  for (let o = 0, i; o < r.length; o++)
    i = r.charCodeAt(o), n = Math.imul(n ^ i, 2654435761), a = Math.imul(a ^ i, 1597334677);
  return n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(a ^ a >>> 13, 3266489909), a = Math.imul(a ^ a >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), 4294967296 * (2097151 & a) + (n >>> 0);
}, le = (r) => typeof r == "object", zt = (r) => typeof r == "function", Jt = (r) => typeof r == "string" && r.startsWith("on"), Xt = (r) => Xe(r) ? !0 : Xe(r == null ? void 0 : r[0]);
function Zt(r) {
  if (Xt(r))
    return Ut.map(r, (n, a) => e(n.props, a));
  if (r != null && r.length)
    return r.map(e);
  return [Qe];
  function e(n, a) {
    return at({}, Qe, n, { index: a });
  }
}
const Qt = (r) => {
  const e = Ce.createContext(void 0);
  e.displayName = r;
  const n = o(e), a = e.Provider;
  return [n, a];
  function o(i) {
    return () => {
      const l = Bt(i);
      if (l)
        return l;
      throw new Error(`The context ${i.displayName} didn't found!`);
    };
  }
}, [P, er] = Qt("MarkedInputStoreProvider");
function tr(r, e, n = !0) {
  let a;
  return () => {
    const i = n && !a;
    clearTimeout(a), a = setTimeout(o, e), i && r.apply(arguments);
  };
  function o() {
    a = void 0, n || r(arguments);
  }
}
function rr(r, e) {
  let n;
  for (let [a, o] of e)
    if (o === r) {
      n = a;
      break;
    }
  return n;
}
function nr(r, e, n, a) {
  return r.slice(0, n) + e + r.slice(n + a.length);
}
class O {
  static get isSelectedPosition() {
    const e = window.getSelection();
    if (!!e)
      return e.isCollapsed;
  }
  static getCurrentPosition() {
    var e, n;
    return (n = (e = window.getSelection()) == null ? void 0 : e.anchorOffset) != null ? n : 0;
  }
  static getFocusedSpan() {
    var e, n, a;
    return (a = (n = (e = window.getSelection()) == null ? void 0 : e.anchorNode) == null ? void 0 : n.textContent) != null ? a : "";
  }
  static getSelectedNode() {
    var n;
    const e = (n = window.getSelection()) == null ? void 0 : n.anchorNode;
    if (e)
      return e;
    throw new Error("Anchor node of selection is not exists!");
  }
  static getAbsolutePosition() {
    var n, a, o;
    const e = (o = (n = window.getSelection()) == null ? void 0 : (a = n.getRangeAt(0)).getBoundingClientRect) == null ? void 0 : o.call(a);
    return e ? {
      left: e.left,
      top: e.top + e.height + 1
    } : {
      left: 0,
      top: 0
    };
  }
  static trySetIndex(e, n) {
    try {
      this.setIndex(e, n);
    } catch (a) {
      console.error(a);
    }
  }
  static setIndex(e, n) {
    const a = window.getSelection();
    if (!(a != null && a.anchorNode) || !a.rangeCount)
      return;
    const o = a.getRangeAt(0);
    o == null || o.setStart(e.firstChild || e, n), o == null || o.setEnd(e.firstChild || e, n);
  }
  static getCaretIndex(e) {
    let n = 0;
    const a = window.getSelection();
    if (!(a != null && a.rangeCount))
      return n;
    const o = a.getRangeAt(0), i = o.cloneRange();
    return i.selectNodeContents(e), i.setEnd(o.endContainer, o.endOffset), n = i.toString().length, n;
  }
  static setCaretToEnd(e) {
    if (!e)
      return;
    const n = window.getSelection();
    n == null || n.setPosition(e, 1);
  }
  static getIndex() {
    var n;
    const e = window.getSelection();
    return (n = e == null ? void 0 : e.anchorOffset) != null ? n : NaN;
  }
  static setIndex1(e) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const a = n.getRangeAt(0);
    a == null || a.setStart(a.startContainer.firstChild || a.startContainer, e), a == null || a.setEnd(a.startContainer.firstChild || a.startContainer, e);
  }
  setCaretRightTo(e, n) {
    const a = window.getSelection(), o = a == null ? void 0 : a.getRangeAt(0);
    o == null || o.setStart(o.endContainer, n), o == null || o.setEnd(o.endContainer, n);
  }
}
const ar = (r) => {
  const e = V(NaN);
  function n() {
    !r.current || (e.current = O.getCaretIndex(r.current));
  }
  function a() {
    !r.current || (O.trySetIndex(r.current, e.current), e.current = NaN);
  }
  return Vt(() => {
    Number.isNaN(e.current) || a();
  }), n;
};
var _ = /* @__PURE__ */ ((r) => (r[r.Change = 0] = "Change", r[r.Delete = 1] = "Delete", r[r.CheckTrigger = 2] = "CheckTrigger", r[r.ClearTrigger = 3] = "ClearTrigger", r[r.Select = 4] = "Select", r))(_ || {}), _e = { exports: {} }, G = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var tt;
function or() {
  if (tt)
    return G;
  tt = 1;
  var r = Ce, e = Symbol.for("react.element"), n = Symbol.for("react.fragment"), a = Object.prototype.hasOwnProperty, o = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, i = { key: !0, ref: !0, __self: !0, __source: !0 };
  function l(f, h, R) {
    var E, w = {}, x = null, k = null;
    R !== void 0 && (x = "" + R), h.key !== void 0 && (x = "" + h.key), h.ref !== void 0 && (k = h.ref);
    for (E in h)
      a.call(h, E) && !i.hasOwnProperty(E) && (w[E] = h[E]);
    if (f && f.defaultProps)
      for (E in h = f.defaultProps, h)
        w[E] === void 0 && (w[E] = h[E]);
    return { $$typeof: e, type: f, key: x, ref: k, props: w, _owner: o.current };
  }
  return G.Fragment = n, G.jsx = l, G.jsxs = l, G;
}
var H = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var rt;
function sr() {
  return rt || (rt = 1, process.env.NODE_ENV !== "production" && function() {
    var r = Ce, e = Symbol.for("react.element"), n = Symbol.for("react.portal"), a = Symbol.for("react.fragment"), o = Symbol.for("react.strict_mode"), i = Symbol.for("react.profiler"), l = Symbol.for("react.provider"), f = Symbol.for("react.context"), h = Symbol.for("react.forward_ref"), R = Symbol.for("react.suspense"), E = Symbol.for("react.suspense_list"), w = Symbol.for("react.memo"), x = Symbol.for("react.lazy"), k = Symbol.for("react.offscreen"), L = Symbol.iterator, fe = "@@iterator";
    function Z(t) {
      if (t === null || typeof t != "object")
        return null;
      var s = L && t[L] || t[fe];
      return typeof s == "function" ? s : null;
    }
    var A = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function g(t) {
      {
        for (var s = arguments.length, u = new Array(s > 1 ? s - 1 : 0), c = 1; c < s; c++)
          u[c - 1] = arguments[c];
        ut("error", t, u);
      }
    }
    function ut(t, s, u) {
      {
        var c = A.ReactDebugCurrentFrame, v = c.getStackAddendum();
        v !== "" && (s += "%s", u = u.concat([v]));
        var m = u.map(function(p) {
          return String(p);
        });
        m.unshift("Warning: " + s), Function.prototype.apply.call(console[t], console, m);
      }
    }
    var ct = !1, lt = !1, ft = !1, dt = !1, ht = !1, Te;
    Te = Symbol.for("react.module.reference");
    function pt(t) {
      return !!(typeof t == "string" || typeof t == "function" || t === a || t === i || ht || t === o || t === R || t === E || dt || t === k || ct || lt || ft || typeof t == "object" && t !== null && (t.$$typeof === x || t.$$typeof === w || t.$$typeof === l || t.$$typeof === f || t.$$typeof === h || t.$$typeof === Te || t.getModuleId !== void 0));
    }
    function vt(t, s, u) {
      var c = t.displayName;
      if (c)
        return c;
      var v = s.displayName || s.name || "";
      return v !== "" ? u + "(" + v + ")" : u;
    }
    function ke(t) {
      return t.displayName || "Context";
    }
    function N(t) {
      if (t == null)
        return null;
      if (typeof t.tag == "number" && g("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof t == "function")
        return t.displayName || t.name || null;
      if (typeof t == "string")
        return t;
      switch (t) {
        case a:
          return "Fragment";
        case n:
          return "Portal";
        case i:
          return "Profiler";
        case o:
          return "StrictMode";
        case R:
          return "Suspense";
        case E:
          return "SuspenseList";
      }
      if (typeof t == "object")
        switch (t.$$typeof) {
          case f:
            var s = t;
            return ke(s) + ".Consumer";
          case l:
            var u = t;
            return ke(u._context) + ".Provider";
          case h:
            return vt(t, t.render, "ForwardRef");
          case w:
            var c = t.displayName || null;
            return c !== null ? c : N(t.type) || "Memo";
          case x: {
            var v = t, m = v._payload, p = v._init;
            try {
              return N(p(m));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var M = Object.assign, Y = 0, Pe, Oe, De, Ae, Ne, Ie, je;
    function Le() {
    }
    Le.__reactDisabledLog = !0;
    function gt() {
      {
        if (Y === 0) {
          Pe = console.log, Oe = console.info, De = console.warn, Ae = console.error, Ne = console.group, Ie = console.groupCollapsed, je = console.groupEnd;
          var t = {
            configurable: !0,
            enumerable: !0,
            value: Le,
            writable: !0
          };
          Object.defineProperties(console, {
            info: t,
            log: t,
            warn: t,
            error: t,
            group: t,
            groupCollapsed: t,
            groupEnd: t
          });
        }
        Y++;
      }
    }
    function Et() {
      {
        if (Y--, Y === 0) {
          var t = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: M({}, t, {
              value: Pe
            }),
            info: M({}, t, {
              value: Oe
            }),
            warn: M({}, t, {
              value: De
            }),
            error: M({}, t, {
              value: Ae
            }),
            group: M({}, t, {
              value: Ne
            }),
            groupCollapsed: M({}, t, {
              value: Ie
            }),
            groupEnd: M({}, t, {
              value: je
            })
          });
        }
        Y < 0 && g("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var de = A.ReactCurrentDispatcher, he;
    function Q(t, s, u) {
      {
        if (he === void 0)
          try {
            throw Error();
          } catch (v) {
            var c = v.stack.trim().match(/\n( *(at )?)/);
            he = c && c[1] || "";
          }
        return `
` + he + t;
      }
    }
    var pe = !1, ee;
    {
      var mt = typeof WeakMap == "function" ? WeakMap : Map;
      ee = new mt();
    }
    function Me(t, s) {
      if (!t || pe)
        return "";
      {
        var u = ee.get(t);
        if (u !== void 0)
          return u;
      }
      var c;
      pe = !0;
      var v = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var m;
      m = de.current, de.current = null, gt();
      try {
        if (s) {
          var p = function() {
            throw Error();
          };
          if (Object.defineProperty(p.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(p, []);
            } catch (I) {
              c = I;
            }
            Reflect.construct(t, [], p);
          } else {
            try {
              p.call();
            } catch (I) {
              c = I;
            }
            t.call(p.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (I) {
            c = I;
          }
          t();
        }
      } catch (I) {
        if (I && c && typeof I.stack == "string") {
          for (var d = I.stack.split(`
`), b = c.stack.split(`
`), y = d.length - 1, C = b.length - 1; y >= 1 && C >= 0 && d[y] !== b[C]; )
            C--;
          for (; y >= 1 && C >= 0; y--, C--)
            if (d[y] !== b[C]) {
              if (y !== 1 || C !== 1)
                do
                  if (y--, C--, C < 0 || d[y] !== b[C]) {
                    var T = `
` + d[y].replace(" at new ", " at ");
                    return t.displayName && T.includes("<anonymous>") && (T = T.replace("<anonymous>", t.displayName)), typeof t == "function" && ee.set(t, T), T;
                  }
                while (y >= 1 && C >= 0);
              break;
            }
        }
      } finally {
        pe = !1, de.current = m, Et(), Error.prepareStackTrace = v;
      }
      var B = t ? t.displayName || t.name : "", Je = B ? Q(B) : "";
      return typeof t == "function" && ee.set(t, Je), Je;
    }
    function Rt(t, s, u) {
      return Me(t, !1);
    }
    function yt(t) {
      var s = t.prototype;
      return !!(s && s.isReactComponent);
    }
    function te(t, s, u) {
      if (t == null)
        return "";
      if (typeof t == "function")
        return Me(t, yt(t));
      if (typeof t == "string")
        return Q(t);
      switch (t) {
        case R:
          return Q("Suspense");
        case E:
          return Q("SuspenseList");
      }
      if (typeof t == "object")
        switch (t.$$typeof) {
          case h:
            return Rt(t.render);
          case w:
            return te(t.type, s, u);
          case x: {
            var c = t, v = c._payload, m = c._init;
            try {
              return te(m(v), s, u);
            } catch {
            }
          }
        }
      return "";
    }
    var re = Object.prototype.hasOwnProperty, Fe = {}, We = A.ReactDebugCurrentFrame;
    function ne(t) {
      if (t) {
        var s = t._owner, u = te(t.type, t._source, s ? s.type : null);
        We.setExtraStackFrame(u);
      } else
        We.setExtraStackFrame(null);
    }
    function Ct(t, s, u, c, v) {
      {
        var m = Function.call.bind(re);
        for (var p in t)
          if (m(t, p)) {
            var d = void 0;
            try {
              if (typeof t[p] != "function") {
                var b = Error((c || "React class") + ": " + u + " type `" + p + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof t[p] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw b.name = "Invariant Violation", b;
              }
              d = t[p](s, p, c, u, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (y) {
              d = y;
            }
            d && !(d instanceof Error) && (ne(v), g("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", c || "React class", u, p, typeof d), ne(null)), d instanceof Error && !(d.message in Fe) && (Fe[d.message] = !0, ne(v), g("Failed %s type: %s", u, d.message), ne(null));
          }
      }
    }
    var wt = Array.isArray;
    function ve(t) {
      return wt(t);
    }
    function xt(t) {
      {
        var s = typeof Symbol == "function" && Symbol.toStringTag, u = s && t[Symbol.toStringTag] || t.constructor.name || "Object";
        return u;
      }
    }
    function _t(t) {
      try {
        return $e(t), !1;
      } catch {
        return !0;
      }
    }
    function $e(t) {
      return "" + t;
    }
    function Be(t) {
      if (_t(t))
        return g("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", xt(t)), $e(t);
    }
    var K = A.ReactCurrentOwner, bt = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Ue, Ve, ge;
    ge = {};
    function St(t) {
      if (re.call(t, "ref")) {
        var s = Object.getOwnPropertyDescriptor(t, "ref").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return t.ref !== void 0;
    }
    function Tt(t) {
      if (re.call(t, "key")) {
        var s = Object.getOwnPropertyDescriptor(t, "key").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return t.key !== void 0;
    }
    function kt(t, s) {
      if (typeof t.ref == "string" && K.current && s && K.current.stateNode !== s) {
        var u = N(K.current.type);
        ge[u] || (g('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', N(K.current.type), t.ref), ge[u] = !0);
      }
    }
    function Pt(t, s) {
      {
        var u = function() {
          Ue || (Ue = !0, g("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(t, "key", {
          get: u,
          configurable: !0
        });
      }
    }
    function Ot(t, s) {
      {
        var u = function() {
          Ve || (Ve = !0, g("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(t, "ref", {
          get: u,
          configurable: !0
        });
      }
    }
    var Dt = function(t, s, u, c, v, m, p) {
      var d = {
        $$typeof: e,
        type: t,
        key: s,
        ref: u,
        props: p,
        _owner: m
      };
      return d._store = {}, Object.defineProperty(d._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(d, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: c
      }), Object.defineProperty(d, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: v
      }), Object.freeze && (Object.freeze(d.props), Object.freeze(d)), d;
    };
    function At(t, s, u, c, v) {
      {
        var m, p = {}, d = null, b = null;
        u !== void 0 && (Be(u), d = "" + u), Tt(s) && (Be(s.key), d = "" + s.key), St(s) && (b = s.ref, kt(s, v));
        for (m in s)
          re.call(s, m) && !bt.hasOwnProperty(m) && (p[m] = s[m]);
        if (t && t.defaultProps) {
          var y = t.defaultProps;
          for (m in y)
            p[m] === void 0 && (p[m] = y[m]);
        }
        if (d || b) {
          var C = typeof t == "function" ? t.displayName || t.name || "Unknown" : t;
          d && Pt(p, C), b && Ot(p, C);
        }
        return Dt(t, d, b, v, c, K.current, p);
      }
    }
    var Ee = A.ReactCurrentOwner, Ye = A.ReactDebugCurrentFrame;
    function $(t) {
      if (t) {
        var s = t._owner, u = te(t.type, t._source, s ? s.type : null);
        Ye.setExtraStackFrame(u);
      } else
        Ye.setExtraStackFrame(null);
    }
    var me;
    me = !1;
    function Re(t) {
      return typeof t == "object" && t !== null && t.$$typeof === e;
    }
    function Ke() {
      {
        if (Ee.current) {
          var t = N(Ee.current.type);
          if (t)
            return `

Check the render method of \`` + t + "`.";
        }
        return "";
      }
    }
    function Nt(t) {
      {
        if (t !== void 0) {
          var s = t.fileName.replace(/^.*[\\\/]/, ""), u = t.lineNumber;
          return `

Check your code at ` + s + ":" + u + ".";
        }
        return "";
      }
    }
    var Ge = {};
    function It(t) {
      {
        var s = Ke();
        if (!s) {
          var u = typeof t == "string" ? t : t.displayName || t.name;
          u && (s = `

Check the top-level render call using <` + u + ">.");
        }
        return s;
      }
    }
    function He(t, s) {
      {
        if (!t._store || t._store.validated || t.key != null)
          return;
        t._store.validated = !0;
        var u = It(s);
        if (Ge[u])
          return;
        Ge[u] = !0;
        var c = "";
        t && t._owner && t._owner !== Ee.current && (c = " It was passed a child from " + N(t._owner.type) + "."), $(t), g('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', u, c), $(null);
      }
    }
    function qe(t, s) {
      {
        if (typeof t != "object")
          return;
        if (ve(t))
          for (var u = 0; u < t.length; u++) {
            var c = t[u];
            Re(c) && He(c, s);
          }
        else if (Re(t))
          t._store && (t._store.validated = !0);
        else if (t) {
          var v = Z(t);
          if (typeof v == "function" && v !== t.entries)
            for (var m = v.call(t), p; !(p = m.next()).done; )
              Re(p.value) && He(p.value, s);
        }
      }
    }
    function jt(t) {
      {
        var s = t.type;
        if (s == null || typeof s == "string")
          return;
        var u;
        if (typeof s == "function")
          u = s.propTypes;
        else if (typeof s == "object" && (s.$$typeof === h || s.$$typeof === w))
          u = s.propTypes;
        else
          return;
        if (u) {
          var c = N(s);
          Ct(u, t.props, "prop", c, t);
        } else if (s.PropTypes !== void 0 && !me) {
          me = !0;
          var v = N(s);
          g("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", v || "Unknown");
        }
        typeof s.getDefaultProps == "function" && !s.getDefaultProps.isReactClassApproved && g("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function Lt(t) {
      {
        for (var s = Object.keys(t.props), u = 0; u < s.length; u++) {
          var c = s[u];
          if (c !== "children" && c !== "key") {
            $(t), g("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", c), $(null);
            break;
          }
        }
        t.ref !== null && ($(t), g("Invalid attribute `ref` supplied to `React.Fragment`."), $(null));
      }
    }
    function ze(t, s, u, c, v, m) {
      {
        var p = pt(t);
        if (!p) {
          var d = "";
          (t === void 0 || typeof t == "object" && t !== null && Object.keys(t).length === 0) && (d += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var b = Nt(v);
          b ? d += b : d += Ke();
          var y;
          t === null ? y = "null" : ve(t) ? y = "array" : t !== void 0 && t.$$typeof === e ? (y = "<" + (N(t.type) || "Unknown") + " />", d = " Did you accidentally export a JSX literal instead of a component?") : y = typeof t, g("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", y, d);
        }
        var C = At(t, s, u, v, m);
        if (C == null)
          return C;
        if (p) {
          var T = s.children;
          if (T !== void 0)
            if (c)
              if (ve(T)) {
                for (var B = 0; B < T.length; B++)
                  qe(T[B], t);
                Object.freeze && Object.freeze(T);
              } else
                g("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              qe(T, t);
        }
        return t === a ? Lt(C) : jt(C), C;
      }
    }
    function Mt(t, s, u) {
      return ze(t, s, u, !0);
    }
    function Ft(t, s, u) {
      return ze(t, s, u, !1);
    }
    var Wt = Ft, $t = Mt;
    H.Fragment = a, H.jsx = Wt, H.jsxs = $t;
  }()), H;
}
(function(r) {
  process.env.NODE_ENV === "production" ? r.exports = or() : r.exports = sr();
})(_e);
const D = _e.exports.jsx, ot = _e.exports.jsxs, ir = nt(({
  id: r,
  value: e
}, n) => {
  const {
    bus: a,
    props: {
      readOnly: o,
      spanStyle: i,
      spanClassName: l
    }
  } = P(), f = V(null);
  typeof n == "function" && n(f);
  const h = ar(f);
  return /* @__PURE__ */ D("span", {
    ref: f,
    style: i,
    className: l,
    contentEditable: !o,
    suppressContentEditableWarning: !0,
    onInput: (E) => {
      var x;
      h();
      const w = (x = E.currentTarget.textContent) != null ? x : "";
      a.send(_.Change, {
        key: r,
        value: w
      });
    },
    onPaste: ur,
    children: e
  });
});
function ur(r) {
  r.preventDefault();
  const e = r.clipboardData.getData("text");
  document.execCommand("insertText", !1, e);
}
const cr = (r) => {
  const e = V(null);
  return X(() => {
    var n;
    if (e.current) {
      const {
        key: a,
        caret: o
      } = e.current;
      let i = (n = r.get(a)) == null ? void 0 : n.current;
      i == null || i.focus(), i && O.trySetIndex(i, o), e.current = null;
    }
  }), e;
};
function S(r, e, n, a) {
  const {
    bus: o
  } = a != null ? a : P();
  X(() => o.listen(r, e), n);
}
const lr = () => {
  const r = U(() => /* @__PURE__ */ new Map(), []), e = ie((n) => (a) => r.set(n, a), []);
  return S(_.Change, () => r.clear(), []), S(_.Delete, () => r.clear(), []), {
    register: e,
    spanRefs: r
  };
}, fr = () => {
  const r = V(null);
  return S("onFocus", (e) => r.current = e.target, []), S("onBlur", (e) => r.current = null, []), r;
};
class dr {
  constructor(e, n, a, o) {
    this.focusedSpanRef = e, this.spanRefs = n, this.recoveryRef = a, this.pieces = o;
  }
  recoverLeft() {
    var o, i;
    let e = (o = this.getPreviousElement()) == null ? void 0 : o.textContent, n = (i = this.focusedSpanRef.current) == null ? void 0 : i.textContent, a = e + n;
    this.recoveryRef.current = {
      key: ue(a),
      caret: e.length
    };
  }
  recoverRight() {
    var o, i;
    let e = (o = this.getNextElement()) == null ? void 0 : o.textContent, n = (i = this.focusedSpanRef.current) == null ? void 0 : i.textContent, a = n + e;
    this.recoveryRef.current = {
      key: ue(a),
      caret: n.length
    };
  }
  getPreviousElement() {
    let e = null;
    if (!this.focusedSpanRef.current)
      return null;
    for (const [n, a] of this.spanRefs) {
      if (a.current === this.focusedSpanRef.current)
        return e;
      e = a.current;
    }
    return null;
  }
  getNextElement() {
    let e = !1;
    if (!this.focusedSpanRef.current)
      return null;
    for (const [n, a] of this.spanRefs) {
      if (e)
        return a.current;
      a.current === this.focusedSpanRef.current && (e = !0);
    }
    return null;
  }
  getPreviousMarkKey() {
    let e = null;
    const n = this.getCurrentKey();
    if (!n)
      return null;
    for (const [a] of this.pieces) {
      if (a === n)
        return e;
      e = a;
    }
    return null;
  }
  getNextMarkKey() {
    let e = !1;
    const n = this.getCurrentKey();
    if (!n)
      return null;
    for (const [a] of this.pieces) {
      if (e)
        return a;
      a === n && (e = !0);
    }
    return null;
  }
  getCurrentKey() {
    if (!this.focusedSpanRef.current)
      return null;
    for (const [e, n] of this.spanRefs)
      if (n.current === this.focusedSpanRef.current)
        return e;
    return null;
  }
}
function hr(r, e, n) {
  const {
    pieces: a,
    bus: o
  } = P();
  S("onKeyDown", (i) => {
    var Z, A;
    const l = new dr(n, r, e, a), f = i.target, h = O.getCaretIndex(f), R = h === 0, E = h === ((Z = f.textContent) == null ? void 0 : Z.length), w = {
      [F.LEFT]: R ? x : null,
      [F.RIGHT]: E ? k : null,
      [F.UP]: null,
      [F.DOWN]: null,
      [F.DELETE]: E ? fe : null,
      [F.BACKSPACE]: R ? L : null
    };
    (A = w[i.key]) == null || A.call(w);
    function x() {
      const g = l.getPreviousElement();
      g == null || g.focus(), O.setCaretToEnd(g), i.preventDefault();
    }
    function k() {
      const g = l.getNextElement();
      g == null || g.focus(), i.preventDefault();
    }
    function L() {
      const g = l.getPreviousMarkKey();
      !g || (l.recoverLeft(), o.send(_.Delete, {
        key: g
      }), i.preventDefault());
    }
    function fe() {
      const g = l.getNextMarkKey();
      !g || (l.recoverRight(), o.send(_.Delete, {
        key: g
      }), i.preventDefault());
    }
  }, [a]);
}
const pr = (r) => {
  S("onClick", () => {
    if (r.size === 1) {
      const e = [...r.values()][0].current;
      (e == null ? void 0 : e.textContent) === "" && e.focus();
    }
  }, []);
}, vr = () => {
  const {
    spanRefs: r,
    register: e
  } = lr(), n = fr(), a = cr(r);
  return hr(r, a, n), pr(r), {
    register: e
  };
};
function gr() {
  const {
    bus: r
  } = P(), e = V(null);
  return X(() => r.set("TextRef", e), []), e;
}
const Er = () => {
  const {
    pieces: r,
    bus: e,
    options: n,
    props: {
      Mark: a,
      ...o
    }
  } = P(), {
    register: i
  } = vr(), l = o.className ? Ze + " " + o.className : Ze, f = gr(), h = U(() => e.events, [e]);
  return /* @__PURE__ */ D("div", {
    ref: f,
    className: l,
    style: o.style,
    ...h,
    children: [...r].map(([R, E]) => {
      var x, k, L;
      if (!le(E))
        return /* @__PURE__ */ D(ir, {
          ref: i(R),
          id: R,
          value: E
        }, R);
      const w = (L = (k = (x = n[E.childIndex]).initMark) == null ? void 0 : k.call(x, E)) != null ? L : E;
      return /* @__PURE__ */ D(a, {
        tabIndex: -1,
        ...w
      }, R);
    })
  });
}, mr = (r) => U(() => Zt(r), [r]), Rr = (r, e) => {
  const n = U(ce.split(r, e), [r]);
  return U(a, [n.length]);
  function a() {
    return n.reduce((i, l) => i.set(o(l, i), l), /* @__PURE__ */ new Map());
    function o(i, l) {
      let f = le(i) ? i.label + i.value : i, h = 0, R = ue(f, h);
      for (; l.has(R); )
        R = ue(f, h++);
      return R;
    }
  }
};
var st = (r, e, n) => {
  if (!e.has(r))
    throw TypeError("Cannot " + n);
}, W = (r, e, n) => (st(r, e, "read from private field"), n ? n.call(r) : e.get(r)), ae = (r, e, n) => {
  if (e.has(r))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(r) : e.set(r, n);
}, ye = (r, e, n) => (st(r, e, "access private method"), n), be, J, q, z, se;
const it = class {
  constructor(...r) {
    ae(this, z), ae(this, be, /* @__PURE__ */ new Map()), ae(this, J, /* @__PURE__ */ new Map()), ae(this, q, {}), r.forEach((e) => W(this, J).set(e, /* @__PURE__ */ new Set()));
  }
  get events() {
    let r = {};
    for (let e of W(this, J).keys())
      r[e] = (n) => this.send(e, n);
    return r;
  }
  static withExternalEventsFrom(r) {
    const e = new Set(Yt);
    return () => new it(...e);
  }
  get(r) {
    if (W(this, q)[r])
      return W(this, q)[r];
    throw new Error(`The ${r} is not exist!`);
  }
  set(r, e) {
    W(this, q)[r] = e;
  }
  send(r, e) {
    ye(this, z, se).call(this, r).forEach((n) => n(e));
  }
  listen(r, e) {
    return ye(this, z, se).call(this, r).add(e), () => ye(this, z, se).call(this, r).delete(e);
  }
};
let yr = it;
be = /* @__PURE__ */ new WeakMap();
J = /* @__PURE__ */ new WeakMap();
q = /* @__PURE__ */ new WeakMap();
z = /* @__PURE__ */ new WeakSet();
se = function(r) {
  const e = Jt(r) ? W(this, J) : W(this, be);
  return e.has(r) || e.set(r, /* @__PURE__ */ new Set()), e.get(r);
};
function Cr(r) {
  const {
    bus: e,
    pieces: n,
    options: a,
    props: o
  } = r;
  S(_.Change, (i) => {
    const {
      key: l,
      value: f = ""
    } = i;
    n.set(l, f), o.onChange(et([...n.values()], a));
  }, [n], r), S(_.Delete, (i) => {
    const {
      key: l
    } = i;
    n.delete(l), o.onChange(et([...n.values()], a));
  }, [n], r), S(_.Select, (i) => {
    const {
      value: l,
      trigger: {
        option: f,
        span: h,
        index: R,
        source: E
      }
    } = i, w = xe(f.markup, l.label, l.value), x = nr(h, w, R, E), k = rr(h, n);
    e.send(_.Change, {
      value: x,
      key: k
    });
  }, [n], r);
}
const wr = ({
  props: r,
  children: e
}) => {
  const n = mr(r.children), a = Rr(r.value, n), o = we(yr.withExternalEventsFrom(r))[0], i = {
    options: n,
    props: r,
    pieces: a,
    bus: o
  };
  return Cr(i), /* @__PURE__ */ ot(er, {
    value: i,
    children: [" ", e, " "]
  });
};
class Se {
  static find(e) {
    if (O.isSelectedPosition)
      return new Se().find(e);
  }
  constructor() {
    let e = O.getCurrentPosition();
    this.node = O.getSelectedNode(), this.span = O.getFocusedSpan(), this.dividedText = this.getDividedTextBy(e);
  }
  getDividedTextBy(e) {
    return {
      left: this.span.slice(0, e),
      right: this.span.slice(e)
    };
  }
  find(e) {
    for (let n of e) {
      let a = this.matchInTextVia(n.trigger);
      if (a)
        return {
          value: a.word,
          source: a.annotation,
          index: a.index,
          span: this.span,
          node: this.node,
          option: n
        };
    }
  }
  matchInTextVia(e) {
    const n = this.matchRightPart(), a = this.matchLeftPart(e);
    if (a)
      return {
        word: a.word + n.word,
        annotation: a.annotation + n.word,
        index: a.index
      };
  }
  matchRightPart() {
    var n;
    const {
      right: e
    } = this.dividedText;
    return {
      word: (n = e.match(Kt)) == null ? void 0 : n[0]
    };
  }
  matchLeftPart(e) {
    var f;
    const n = this.makeTriggerRegex(e), {
      left: a
    } = this.dividedText, o = a.match(n);
    if (!o)
      return;
    const [i, l] = o;
    return {
      word: l,
      annotation: i,
      index: (f = o.index) != null ? f : 0
    };
  }
  makeTriggerRegex(e) {
    const n = oe(e) + "(\\w*)$";
    return new RegExp(n);
  }
}
const xr = () => {
  const [r, e] = we(), {
    options: n
  } = P();
  return S(_.ClearTrigger, (a) => e(void 0), []), S(_.CheckTrigger, (a) => e(Se.find(n)), [n]), r;
}, _r = nt(({
  trigger: r,
  style: e,
  onSelect: n
}, a) => {
  const [o, i] = we(NaN), l = U(() => r.option.data.filter((f) => f.toLowerCase().indexOf(r.value.toLowerCase()) > -1), [r.value]);
  return l.length ? /* @__PURE__ */ D("ul", {
    ref: a,
    className: "mk-suggestions",
    style: e,
    children: l.map((f, h) => {
      let R;
      return h === o && (R = "mk-suggestion-active"), /* @__PURE__ */ D("li", {
        className: R,
        onClick: (E) => n({
          label: f,
          value: h.toString()
        }),
        children: f
      }, f);
    })
  }) : null;
});
function br(r) {
  var l, f, h;
  const {
    bus: e
  } = P(), n = ie(() => e.send(_.ClearTrigger), []), a = ie((R) => e.send(_.Select, {
    value: R,
    trigger: r
  }), [r]), o = O.getAbsolutePosition(), i = {
    trigger: r,
    style: o,
    onSelect: a,
    onClose: n
  };
  return (h = (f = (l = r.option).initOverlay) == null ? void 0 : f.call(l, i)) != null ? h : i;
}
function Sr(r) {
  const {
    bus: e
  } = P();
  X(() => {
    const n = (a) => {
      let o = a.target;
      o !== r.current && o !== e.get("TextRef").current && (o == null ? void 0 : o.parentElement) !== e.get("TextRef").current && e.send(_.ClearTrigger);
    };
    return document.addEventListener("click", n), () => document.removeEventListener("click", n);
  }, []);
}
function Tr() {
  const {
    bus: r
  } = P();
  X(() => {
    const e = (n) => {
      n.key === F.ESC && r.send(_.ClearTrigger);
    };
    return window.addEventListener("keydown", e), () => window.removeEventListener("keydown", e);
  }, []);
}
const kr = (r) => {
  const e = V(null);
  Tr(), Sr(e);
  const n = br(r), {
    props: {
      Overlay: a = _r
    }
  } = P();
  return /* @__PURE__ */ D(a, {
    ref: e,
    ...n
  });
};
function Pr() {
  const {
    bus: r
  } = P(), e = ie(tr(() => r.send(_.CheckTrigger), 20), []);
  S("onFocus", (n) => document.addEventListener("selectionchange", e, {}), []), S("onBlur", (n) => document.removeEventListener("selectionchange", e), []);
}
const Or = () => {
  Pr();
  const r = xr();
  return r ? /* @__PURE__ */ D(kr, {
    ...r
  }, r.option.index) : null;
};
function Dr(r) {
  return /* @__PURE__ */ ot(wr, {
    props: r,
    children: [/* @__PURE__ */ D(Er, {}), /* @__PURE__ */ D(Or, {})]
  });
}
const Ir = ({
  trigger: r = "@",
  markup: e = "@[__label__](__value__)",
  data: n = [],
  ...a
}) => null;
function jr(r, e, n) {
  const a = zt(e) ? {
    Mark: r,
    Overlay: e,
    children: n
  } : {
    Mark: r,
    children: e
  };
  return (o) => {
    const i = at({}, o, a);
    return Dr(i);
  };
}
export {
  Dr as MarkedInput,
  Ir as Option,
  xe as annotate,
  jr as createMarkedInput,
  Nr as denote
};
//# sourceMappingURL=index.js.map
